unit ResolutionFunction;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, EditReal, EditData, JvComponent, JvFormPlace;

type
  TResolutionFonctionForm = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Wslit1Box: TEditReal;
    Label2: TLabel;
    Label3: TLabel;
    Wslit2box: TEditReal;
    Label4: TLabel;
    Label5: TLabel;
    CollDist: TEditReal;
    Label6: TLabel;
    DetDist: TEditReal;
    PlotButton: TButton;
    GroupBox2: TGroupBox;
    Label7: TLabel;
    y3box: TEditReal;
    Label8: TLabel;
    JvFormPlace1: TJvFormPlace;
    Label9: TLabel;
    yStepBox: TEditReal;
    procedure PlotButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  ResolutionFonctionForm: TResolutionFonctionForm;

implementation

uses MainForm;

{$R *.dfm}

{ calculation and plot of the reoslution function       }
{ INPUT : from the graphical window                     }
{ OUPUT : a spectrum containing the resolution function }
{         as measured on the detector                   }
procedure TResolutionFonctionForm.PlotButtonClick(Sender: TObject);
var i,ind:integer;
    a1,a2,C1,C2,y3max,yStep,alpha,Y3,Intensity,y:double;
begin
   a1:=Wslit1box.value; { largeur fente 1 en mm }
   a2:=Wslit2box.value; { largeur fente 2 en mm }
   C1:=CollDist.value; { collimation distance }
   C2:=DetDist.value;  { dtector distance }
   alpha:=C1/(C1+C2);
   y3max:=y3box.value;
   ystep:=YstepBox.value;
   { calcul de la function de resolution proprement dite }
   { calcul " la main" }
   ind:=und.addspectre('resolution',round(y3max/yStep)+1,1,1);
   for i:=0 to round(y3max/yStep) do
   begin
       y3:=-round(y3max/2)+i*yStep;
       Intensity:=0;
       y:=-a1/2;
       while y<=a1/2 do
       begin
           if ((alpha*(y3-y)+y)>(-a2/2)) and ((alpha*(y3-y)+y)<(a2/2))
           then Intensity:=Intensity+10000*yStep/(2*3.14*(C1+C2)); { I1 * dy1 / 2pi(C1+C2) }
           y:=y+yStep;
       end;
       { remplissage du spectre 1D }
       und.spect[ind].data[i,0,0].x:=y3;
       und.spect[ind].data[i,0,0].z:=Intensity;
   end;
   sendmessage(principalform.handle,wm_redessine,0,0);
end;

procedure TResolutionFonctionForm.FormCreate(Sender: TObject);
begin
   left:=0;top:=0;width:=169;height:=253;
   WindowState:=wsMinimized;
end;

end.
