unit Tiltof;
{ simulation des rsultats attendus d'une manip de TilTOF                       }
{ cette unit ralise aussi la dconvolution                                    }
{ calibration raisonable                                                        }
{ MA11000 ; pixel 160 ; Ti = 0.925                                              }
{ Fit de la trajectoire                                                         }
{ A * sin (B x) + C ; A = 3300 ; B = 0.17 ; C = 14400                           }
{ Channel width 150 s                                                          }
{ 
{ ***************************************************************************** }
{ A FAIRE                                                                       }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, EditReal, Menus,EditData, Spin,MtxVec,
  MtxBaseComp, MtxVecEdit, JvComponent, JvArrow, ComCtrls, math,
  JvSpecialImage;

type
  TTiltofForm = class(TForm)
    MainMenu1: TMainMenu;
    FIle1: TMenuItem;
    OpenWhiteBeamSpectrum1: TMenuItem;
    Calculate1: TMenuItem;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel1: TPanel;
    Label7: TLabel;
    Label8: TLabel;
    StatusLabel: TLabel;
    JvArrow1: TJvArrow;
    Label15: TLabel;
    Label16: TLabel;
    JvArrow3: TJvArrow;
    JvArrow4: TJvArrow;
    JvArrow5: TJvArrow;
    Label17: TLabel;
    Label18: TLabel;
    JvArrow2: TJvArrow;
    SimulButton: TButton;
    ReconstructButton: TButton;
    ReflectivitySpectrum: TEdit;
    WhiteBeamSpectrum: TEdit;
    DataSpectrumName: TEdit;
    ReconstructedSpectrum: TEdit;
    COnvolute2DButton: TButton;
    DataConv2D: TEdit;
    Convolute1DButton: TButton;
    DataConv1D: TEdit;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    ThetaMinBox: TEditReal;
    ThetaStepBox: TEditReal;
    ThetaMaxBox: TEditReal;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label4: TLabel;
    Label2: TLabel;
    LambdaMinBox: TEditReal;
    LambdaStepBox: TEditReal;
    LambdaMaxBox: TEditReal;
    GroupBox3: TGroupBox;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    QzMinBox: TEditReal;
    QzStepBox: TEditReal;
    QzMaxBox: TEditReal;
    UpdateQzButton: TButton;
    GroupBox4: TGroupBox;
    Label9: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    dTResolutionBox: TEditReal;
    dLResolutionBox: TEditReal;
    nPtsResolution: TSpinEdit;
    TabSheet2: TTabSheet;
    GroupBox5: TGroupBox;
    Panel2: TPanel;
    RawDataBox: TEdit;
    JvArrow7: TJvArrow;
    CalcTiButton: TButton;
    DataTcalBox: TEdit;
    Label24: TLabel;
    TicalBox: TEditReal;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    MAcalBox: TSpinEdit;
    Label28: TLabel;
    DistanceBox: TEditReal;
    Label29: TLabel;
    Label30: TLabel;
    PixelSizeBox: TEditReal;
    Label31: TLabel;
    JvArrow8: TJvArrow;
    MapLambdaButton: TButton;
    DataLambdaCalBox: TEdit;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Channel0ABox: TSpinEdit;
    PixelSizeMAbox: TEditReal;
    Label36: TLabel;
    Label37: TLabel;
    JvArrow9: TJvArrow;
    MapQbutton: TButton;
    dataQbox: TEdit;
    DataLambdaNormBox: TEdit;
    NormLambdaButton: TButton;
    JvArrow10: TJvArrow;
    WhiteBeamBox: TEdit;
    Label19: TLabel;
    PixCalBox: TEditReal;
    TabSheet3: TTabSheet;
    Memo: TMemo;
    ChannelWidthBox: TEditReal;
    Label41: TLabel;
    Label42: TLabel;
    Channel0Rbox: TSpinEdit;
    Saveparameters1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Label45: TLabel;
    ilTOF1: TMenuItem;
    QzminDPbox: TEditReal;
    Label46: TLabel;
    Label47: TLabel;
    QzStepDPbox: TEditReal;
    QzMaxDPbox: TEditReal;
    Label48: TLabel;
    Label49: TLabel;
    JvSpecialImage1: TJvSpecialImage;
    TrajAllerBox: TEdit;
    TrajRetourBox: TEdit;
    PlotTrajButton: TButton;
    Memo1: TMemo;
    EditReal1: TEditReal;
    Label20: TLabel;
    Label43: TLabel;
    Label44: TLabel;
    LminBox: TEditReal;
    LstepBox: TEditReal;
    Label50: TLabel;
    Label51: TLabel;
    LmaxBox: TEditReal;
    Label52: TLabel;
    TrajectoryBox: TEdit;
    ProcessTrajectoryButton: TButton;
    AllButton: TButton;
    procedure UpdateQzButtonClick(Sender: TObject);
    procedure SimulButtonClick(Sender: TObject);
    procedure ReconstructButtonClick(Sender: TObject);
    procedure COnvolute2DButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Convolute1DButtonClick(Sender: TObject);
    procedure CalcTiButtonClick(Sender: TObject);
    procedure MapLambdaButtonClick(Sender: TObject);
    procedure MapQbuttonClick(Sender: TObject);
    procedure NormLambdaButtonClick(Sender: TObject);
    procedure CalcTi;
    procedure MapLambda;
    procedure MapQ;
    procedure NormLambda;
    procedure AllButtonClick(Sender: TObject);
    procedure PlotTrajButtonClick(Sender: TObject);
    procedure ProcessTrajectoryButtonClick(Sender: TObject);

  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  TiltofForm: TTiltofForm;

implementation

{$R *.dfm}

{ update de la gamme Qz mesure  partir des tendues lambda et theta           }
procedure TTiltofForm.UpdateQzButtonClick(Sender: TObject);
begin
   QzMinBox.value:=4*Pi/lambdaMaxBox.value*sin(ThetaMinBox.value*Pi/180);
   QzMaxBox.value:=4*Pi/lambdaMinBox.value*sin(ThetaMaxBox.value*Pi/180);
end;


{ simulation des data mesures sur le dtecteur dans une manip TILTOF           }
{ INPUT :  lambda, theta, courbe de reflectivit                                }
{ OUTPUT : une courbe de reflectivit                                           }
procedure TTiltofForm.SimulButtonClick(Sender: TObject);
var lambda,lambdamin,lambdamax,lambdastep:double;
    theta,thetamin,thetamax,thetastep:double;
    Q:double;
    nlambda,ntheta:integer; { nombre de points en lambda et en theta }
    i,j,ind,indWB,indR:integer;
    R,Intensity:double;
begin
    statusLabel.caption:='Calculating';statusLabel.update;
    lambdaMin:=lambdaMinBox.value;
    lambdaMax:=lambdaMaxBox.value;
    lambdaStep:=lambdaStepBox.value;
    nlambda:=round((lambdamax-lambdamin)/lambdaStep)+1;
    thetaMin:=thetaMinBox.value;
    thetaMax:=thetaMaxBox.value;
    thetaStep:=thetaStepBox.value;
    ntheta:=round((thetamax-thetamin)/thetaStep)+1;
    { creation du spectre de sortie }
    ind:=deuxd.addspectre(dataSPectrumName.text,ntheta,nlambda,1);
    indWB:=und.indexof(WhiteBeamSPectrum.text);
    indR:=und.indexof(ReflectivitySpectrum.text);
    { remplissage du spectre 2D }
    For i:=0 to ntheta-1 do
       For j:=0 to nlambda-1 do
          begin
             lambda:=lambdaMin+j*lambdaStep;
             theta:=thetaMin+i*thetaStep;
             Q:=4*Pi/lambda*sin(Theta*Pi/180);
             { soit  dterminer la rflectivit pour ce vecteur Q }
             R:=und.spect[indR].interpolate(Q);
             { soit  dterminer l'intensit pour ce vecteur lambda }
             Intensity:=und.spect[indWB].interpolate(lambda);
             deuxd.spect[ind].data[i,j,0].x:=theta;
             deuxd.spect[ind].data[i,j,0].y:=lambda;
             deuxd.spect[ind].data[i,j,0].z:=R*Intensity;
          end;
    statusLabel.caption:='Finished';statusLabel.update;
end;

{ procedure de reconstruction de la courbe de rflectivit  partir des data de TILTOF }
{ INPUT : la mesure 2D (theta, lambda)                                          }
{ OUTPUT : la courbe de reflectivit reconstruite                               }
procedure TTiltofForm.ReconstructButtonClick(Sender: TObject);
var lambda,lambdamin,lambdamax,lambdastep:double;
    theta,thetamin,thetamax,thetastep:double;
    Q,qmin,qmax,qstep:double;
    nlambda,ntheta,nQ:integer;
    iQ,i,j,ind1D,ind2D,indWB:integer;
    intensity:double;
    renorm:array[0..1000] of integer;
begin
    statusLabel.caption:='Calculating';statusLabel.update;
    lambdaMin:=lambdaMinBox.value;
    lambdaMax:=lambdaMaxBox.value;
    lambdaStep:=lambdaStepBox.value;
    nlambda:=round((lambdamax-lambdamin)/lambdaStep)+1;
    thetaMin:=thetaMinBox.value;
    thetaMax:=thetaMaxBox.value;
    thetaStep:=thetaStepBox.value;
    ntheta:=round((thetamax-thetamin)/thetaStep)+1;
    QMin:=QzMinBox.value;
    QMax:=QzMaxBox.value;
    QStep:=QzStepBox.value;
    nQ:=round((Qmax-Qmin)/QStep)+1;
    { creation du spectre de sortie }
    ind2D:=deuxd.indexof(dataSPectrumName.text);
    indWB:=und.indexof(dataSPectrumName.text);
    ind1D:=und.addspectre(ReconstructedSPectrum.text,nQ,1,1);
    for iQ:=0 to nQ-1 do renorm[iQ]:=0;
    { remplissage du spectre 2D }
    For i:=0 to ntheta-1 do
       For j:=0 to nlambda-1 do
          begin
             lambda:=lambdaMin+j*lambdaStep;
             theta:=thetaMin+i*thetaStep;
             Q:=4*Pi/lambda*sin(Theta*Pi/180);
             { soit  dterminer l'intensit pour ce vecteur lambda }
             Intensity:=und.spect[indWB].interpolate(lambda);
             { soit  dterminer la rflectivit pour ce vecteur Q }
             { index de la position en Q }
             iQ:=round((Q-Qmin)/Qstep);
             if (iQ>=0) and (iQ<nQ) then
             begin und.spect[ind1D].data[iQ,0,0].x:=Q;
                   und.spect[ind1D].data[iQ,0,0].z:=und.spect[ind1D].data[iQ,0,0].z+deuxd.spect[ind2D].data[i,j,0].z/Intensity;
                   renorm[iQ]:=renorm[iQ]+1; end;
          end;
    { renormalisation des data par la densit de points de mesures }
    for iQ:=0 to nQ-1 do und.spect[ind1D].data[iQ,0,0].z:=und.spect[ind1D].data[iQ,0,0].z/renorm[iQ];
    statusLabel.caption:='Finished';statusLabel.update;
end;

{ convolution du spectre mesur avec la resolution en theta et en lambda }
{ INPUT : (graphique) dTheta et dLmabda/lambda                                  }
procedure TTiltofForm.COnvolute2DButtonClick(Sender: TObject);
var lambda,lambdamin,lambdamax,lambdastep,dlambda:double;
    theta,thetamin,thetamax,thetastep,dtheta,sigTheta,sigLambda:double;
    i,i0,j,j0,ind,indCV,indRESO,ntheta,nlambda:integer;
    X,H,CV:TMtx;
    ResoThetaLength,ResoLambdaLength:integer;
begin
    statusLabel.caption:='Calculating';statusLabel.update;
    resoThetalength:=nPtsResolution.value;
    resoLambdalength:=nPtsResolution.value;
    ind:=deuxd.indexof(dataSPectrumName.text);
    nTheta:=deuxd.spect[ind].X;
    thetaMin:=deuxd.spect[ind].data[0,0,0].x;
    thetaMax:=deuxd.spect[ind].data[nTheta-1,0,0].x;
    thetaStep:=(deuxd.spect[ind].data[1,0,0].x-deuxd.spect[ind].data[0,0,0].x);
    nLambda:=deuxd.spect[ind].Y;
    lambdaMin:=deuxd.spect[ind].data[0,0,0].y;
    lambdaMax:=deuxd.spect[ind].data[nLambda-1,0,0].y;
    lambdaStep:=(deuxd.spect[ind].data[0,1,0].y-deuxd.spect[ind].data[0,0,0].y);
    indRESO:=deuxd.addspectre('Resolution',resoThetaLength,resoLambdaLength,1); { fonction de convolution }
    indCV:=deuxd.addspectre(dataConv2D.Text,nTheta,nLambda,1);  { spectre convolu }

    CreateIt(X,H,CV);
    X.size(nTheta,nLambda);X.setval(0);
    H.size(resoThetalength,resoLambdalength);H.setval(0);
    CV.size(nTheta+resoThetalength,nLambda+resoLambdalength);CV.setval(0);    { creation de la matrice de convolution/resolution }
    { on met theta=0 au centre de la matrice }
    sigTheta:=dTResolutionBox.value;
    sigLambda:=dLResolutionBox.value;
    For i:=0 to resoThetaLength-1 do
       For j:=0 to resoLambdaLength-1 do
          begin
             theta:=(i-trunc(resoThetaLength/2))*thetaStep;
             lambda:=(j-trunc(resoLambdaLength/2))*lambdaStep;
             deuxd.spect[indRESO].data[i,j,0].x:=theta;
             deuxd.spect[indRESO].data[i,j,0].y:=lambda;
             deuxd.spect[indRESO].data[i,j,0].z:=1/(sigTheta*sqrt(2*pi))*exp(-0.5*sqr(theta/sigTheta))*1/(sigLambda*sqrt(2*pi))*exp(-0.5*sqr(lambda/sigLambda));
             H.values[i,j]:=deuxd.spect[indRESO].data[i,j,0].z;
          end;
    { transfert de la courve dns le vecteur X }
    For i:=0 to ntheta-1 do For j:=0 to nlambda-1 do X.values[i,j]:=deuxd.spect[ind].data[i,j,0].z;
    { convolution proprement dite }
    CV.convolve(X,H,false);
    { remplissage de la matrice resultat }
    For i:=trunc(resoThetaLength/2) to CV.rows-1-trunc(resoThetaLength/2) do
       For j:=trunc(resoLambdaLength/2) to CV.cols-1-trunc(resoLambdaLength/2) do
          begin
             theta:=thetaMin+(i-trunc(resoThetaLength/2))*thetaStep;
             lambda:=lambdaMin+(j-trunc(resoLambdaLength/2))*lambdaStep;
             deuxd.spect[indCV].data[i-trunc(resoThetaLength/2),j-trunc(resoLambdaLength/2),0].x:=theta;
             deuxd.spect[indCV].data[i-trunc(resoThetaLength/2),j-trunc(resoLambdaLength/2),0].y:=lambda;
             deuxd.spect[indCV].data[i-trunc(resoThetaLength/2),j-trunc(resoLambdaLength/2),0].z:=CV[i,j]*thetaStep*lambdaStep;
          end;
    FreeIt(X,H,CV);
    statusLabel.caption:='Finished';statusLabel.update;
end;

procedure TTiltofForm.FormCreate(Sender: TObject);
begin
{ positionnement par dfaut de la fntre }
  left:=0;top:=0;width:=467;height:=500;
  WindowState:=wsMinimized;
end;

{ Convolution d'une courbe theorique avec la resolution                         }
{ !!! pour le momeent, convolution uniquement en  theta                         }
procedure TTiltofForm.Convolute1DButtonClick(Sender: TObject);
var lambda,lambdamin,lambdamax,lambdastep,dlambda:double;
    theta,thetamin,thetamax,thetastep,dtheta,sig:double;
    i,ind,indCV,indRESO,ntheta,resoLength:integer;
    X,H,CV:TVec;
begin
    statusLabel.caption:='Calculating';statusLabel.update;
    resolength:=nPtsResolution.value;
    ind:=und.indexof(reflectivitySPectrum.text);
    nTheta:=und.spect[ind].X;
    thetaMin:=und.spect[ind].data[0,0,0].x;
    thetaMax:=und.spect[ind].data[nTheta-1,0,0].x;
    thetaStep:=(und.spect[ind].data[1,0,0].x-und.spect[ind].data[0,0,0].x);
    indRESO:=und.addspectre('Resolution',resoLength,1,1); { fonction de convolution }
    indCV:=und.addspectre(dataConv1D.Text,nTheta,1,1);  { spectre convolu }

    CreateIt(X,H,CV);
    X.size(nTheta);X.setval(0);H.size(resoLength);H.setval(0);
    CV.size(nTheta+resoLength);CV.setval(0);
    { creation de la matrice de convolution/resolution }
    { on met theta=0 au centre de la matrice }
    sig:=dTResolutionBox.value;
    
    For i:=0 to resoLength-1 do
          begin
             theta:=(i-trunc(resoLength/2))*thetaStep;
             und.spect[indRESO].data[i,0,0].x:=theta;
             und.spect[indRESO].data[i,0,0].z:=1/(sig*sqrt(2*pi))*exp(-0.5*sqr(theta/sig));
             H.values[i]:=und.spect[indRESO].data[i,0,0].z;
          end;
    { transfert de la courve dns le vecteur X }
    For i:=0 to ntheta-1 do X.values[i]:=und.spect[ind].data[i,0,0].z;
    { convolution proprement dite }
    CV.convolve(X,H);
    { remplissage de la matrice resultat }
    For i:=trunc(resoLength/2) to CV.Length-1-trunc(resoLength/2) do
          begin
             theta:=thetaMin+(i-trunc(resoLength/2))*thetaStep;
             und.spect[indCV].data[i-trunc(resoLength/2),0,0].x:=theta;
             und.spect[indCV].data[i-trunc(resoLength/2),0,0].z:=CV[i]*thetaStep;
          end;
    FreeIt(X,H,CV);
    statusLabel.caption:='Finished';statusLabel.update;
end;

{ calibration de l'axe des ordonnes                                            }
{ passage d'une valeur en pixel sur le dtecteur  une valeur en Thetai en deg  }
procedure TTiltofForm.CalcTi;
var ind,indT:integer;
    i,j:integer;
    sizeX,sizeY:integer;
    dtheta:double;
begin
   ind:=deuxd.indexof(dataLambdaNormBox.text);
   if ind=-1
   then begin MessageDlg('Le spectre de data n''existe pas !', mtInformation,[mbOk], 0);exit end
   else begin
        sizeX:=deuxd.spect[ind].X;sizeY:=deuxd.spect[ind].Y;
        indT:=deuxd.addspectre(DataTCalBox.text,sizeX,sizeY,1);
        { delta theta par pixel du dtecteur }
        dtheta:=PixelSizeBox.value/DistanceBox.value*180/pi/2; { en degres }
        for i:=0 to sizeX-1 do
          for j:=0 to sizeY-1 do
          begin
          deuxd.spect[indT].data[i,sizeY-1-j,0].X:=deuxd.spect[ind].data[i,j,0].X;
          deuxd.spect[indT].data[i,sizeY-1-j,0].Y:=TiCalBox.value+(PixCalBox.value-j)*dtheta; { on inverse les abscisses }
          deuxd.spect[indT].data[i,sizeY-1-j,0].Z:=deuxd.spect[ind].data[i,j,0].Z;
          end;
        end;
end;

{ calibration de l'axe des ordonnes                                            }
{ passage d'une valeur en pixel sur le dtecteur  une valeur en Thetai en deg  }
procedure TTiltofForm.CalcTiButtonClick(Sender: TObject);
begin CalcTi end;

{ Remapping des data dans les axe (canal - theta)                               }
{ sur une matrice rectangulaire (lambda - theta                                 }
{ il faut avoir fitt la trajectoire avec une fonction A*sin(x)+B               }
{ on remonte d'une position  un temps de vol                                   }
{ on a besoin de la position du top de dpart du TdV                            }
{ v = h / (m lambda)                                                            }
{ lambda = h t / m D                                                            }
{ h = 6.63e-34 ; mn = 1.67e-27                                                  }
{ lambda = 3.956 * t(s) / D (mm)                                               }
{ 1/ comprendre pourquoi la pente double entre aller et retour                 }
{ seule explication plausible : A et R ne sont pas symmmtriques                }
{ 2/ corriger l'offset de Tof entre les diffrentes lignes de Mesures          }
{ 3/ calibrer l'axe des abscisses en lambda                                    }
{ on peut calibrer les longueurs d'onde simplement en faisant la mesure avec un }
{ le graphite en place le long du trajet                                        }
{ voir comment optimiser les trajectoires                                       }
{ DANGER : il faut que les courbes de trajectroir soient gradues dans le bon   }
{ sens sinon la procedure interpolation foire                                   }
procedure TTiltofForm.MapLambda;
var indA,indR,indAi,indRi,ind,indL,indCH:integer;
    i,j:integer;
    sizeX,sizeY,sizeXA,sizeXR:integer;
    MA,t,pix0,MAperDegree,pixel,lambda,pix:double;
    Lmin,Lmax,Lstep,channelWidth,pixCal,pixelSizeMA,MaCal,channel0A,Distance:double;
begin
   { inversion des trajectoires Aller et Retour                                 }
   { pour pouvoir directement obtenir le temps  partir de MA                   }
   indA:=und.indexof(TrajAllerBox.text);sizeXA:=und.spect[indA].X;
   indR:=und.indexof(TrajRetourBox.text);sizeXR:=und.spect[indR].X;
   if (indA=-1) or (indR=-1) then begin MessageDlg('Le spectre de data n''existe pas !', mtInformation,[mbOk], 0);exit end;
   indAi:=und.addspectre(TrajAllerBox.text+'I',sizeXA,1,1);
   indRi:=und.addspectre(TrajRetourBox.text+'I',sizeXR,1,1);
   for i:=0 to sizeXA-1 do
   begin
      und.spect[indAi].data[i,0,0].X:=und.spect[indA].data[i,0,0].Z;
      und.spect[indAi].data[i,0,0].Z:=und.spect[indA].data[i,0,0].X;
   end;
   for i:=0 to sizeXR-1 do
   begin
      und.spect[indRi].data[i,0,0].X:=und.spect[indR].data[i,0,0].Z;
      und.spect[indRi].data[i,0,0].Z:=und.spect[indR].data[i,0,0].X;
   end;
   { reconstruction proprement dite                                             }
   ind:=deuxd.indexof(RawDataBox.text);    { spectre d'entre gradu en (canal - pixel) }
   if (ind=-1) then begin MessageDlg('Le spectre de data n''existe pas !', mtInformation,[mbOk], 0);exit end;
   { creation de la matrice carre de sortie (lambda - theta)                   }
   Lmin:=LminBox.value;Lmax:=LmaxBox.value;Lstep:=LstepBox.value;
   sizeX:=round((Lmax-Lmin)/Lstep)+1;sizeY:=deuxd.spect[ind].Y; { on utilise la paramtrisation en S }
   indL:=deuxd.addspectre(DataLambdaCalBox.text,sizeX,sizeY,1); { le spectre gradu en lambda en abscisse }
   { la position de calibration }
   { qu'est ce que la variable Pixel0 ? }
   { balayage du spectre de sortie en lambda }
   channelWidth:=channelWidthBox.value;
   pixCal:=PixCalBox.value;pixelSizeMA:=PixelSizeMABox.value;
   MaCal:=MaCalBox.value;channel0A:=channel0ABox.value;
   Distance:=DistanceBox.value;
   for j:=0 to sizeY-1 do
   begin
      pixel:=deuxd.spect[ind].data[0,j,0].Y; { pixel de travail }
      { creation de la coupe horizontale le long de theta }
      unD.add(deuxd.spect[ind].CoupeHSpectre2D('CH',pixel));indCH:=unD.indexof('CH');
      for i:=0 to sizeX-1 do
      begin
         lambda:=Lmin+i*Lstep;
         deuxd.spect[indL].data[i,j,0].X:=lambda;
         deuxd.spect[indL].data[i,j,0].Y:=pixel;
         { soit  retrouver sur la ligne j l'intensit correspondant  lambda   }
         { dtermination de la position MA  laquelle correspond la ligne j }
         MA:=(PixCal-pixel)*PixelSizeMA+MaCal; { les j croissants correspondent  des MA decroissants ; j diminue quand theta augmente }
         { dcalage temporel }
         t:=und.spect[indAi].interpolate(MA)*1000; { le facteur 1000 vient du fait qu'on calibre la trajectoire en ms et on veut t en s }
         { premier pixel correspondant au dbut du TOF }
         pix0:=channel0A+t/channelWidth;
         { recherche du canal de temps de vol correspondant  lambda }
         pix:=lambda*Distance/ChannelWidth/3.956+pix0;
         deuxd.spect[indL].data[i,j,0].Z:=und.spect[indCH].interpolate(pix);
         { trajet retour }
      end
   end;
end;

{ calibration de l'axe de temps de vol (abscisses)                              }
{ il faut avoir fitt la trajectoire avec une fonction A*sin(x)+B               }
{ on remonte d'une position  un temps de vol                                   }
{ on a besoin de la position du top de dpart du TdV                            }
{ v = h / (m lambda)                                                            }
{ lambda = h t / m D                                                            }
{ h = 6.63e-34 ; mn = 1.67e-27                                                  }
{ lambda = 3.956 * t(s) / D (mm)                                               }
{ 1/ comprendre pourquoi la pente double entre aller et retour                 }
{ seule explication plausible : A et R ne sont pas symmmtriques                }
{ 2/ corriger l'offset de Tof entre les diffrentes lignes de Mesures          }
{ 3/ calibrer l'axe des abscisses en lambda                                    }
{ on peut calibrer les longueurs d'onde simplement en faisant la mesure avec un }
{ le graphite en place le long du trajet                                        }
{ voir comment optimiser les trajectoires                                       }
procedure TTiltofForm.MapLambdaButtonClick(Sender: TObject);
begin MapLambda end;

{ normalisation des intensits par le faisceau incident                         }
{ faisceau mesur en faisceau direct                                            }
procedure TTiltofForm.NormLambda;
var indLcal,indLnorm,indW:integer;
    i,j:integer;
    sizeX,sizeY:integer;
    lambda,intensity:double;
begin
   indLcal:=deuxd.indexof(DataLambdaCalBox.text);
   indW:=und.indexof(WhiteBeamBox.text);
   if (indLcal=-1) or (indW=-1) then begin MessageDlg('Le spectre de data n''existe pas !', mtInformation,[mbOk], 0);exit end;
   sizeX:=deuxd.spect[indLcal].X;sizeY:=deuxd.spect[indLcal].Y;
   indLnorm:=deuxd.addspectre(dataLambdaNormbox.text,sizeX,sizeY,1);
   for j:=0 to sizeY-1 do
     for i:=0 to sizeX-1 do
     begin
        { dtermination de l'intensit pour une longueur d'onde donne             }
        lambda:=deuxd.spect[indLcal].data[i,j,0].X;
        deuxd.spect[indLnorm].data[i,j,0].X:=lambda;
        deuxd.spect[indLnorm].data[i,j,0].Y:=deuxd.spect[indLcal].data[i,j,0].Y;
        intensity:=und.spect[indW].interpolate(lambda);
        if intensity>0
        then deuxd.spect[indLnorm].data[i,j,0].Z:=deuxd.spect[indLcal].data[i,j,0].Z/intensity
        else deuxd.spect[indLnorm].data[i,j,0].Z:=0;
     end
end;

{ normalisation des intensits par le faisceau incident                         }
{ faisceau mesur en faisceau direct                                            }
procedure TTiltofForm.NormLambdaButtonClick(Sender: TObject);
begin NormLambda end;

procedure TTiltofForm.MapQ;
var ind,indQ,indCH:integer;
    i,j:integer;
    sizeX,sizeY,nQ:integer;
    Q,Qmin,Qmax,QStep,lambda,theta:double;
begin
   ind:=deuxd.indexof(DataTcalBox.text);
   if (ind=-1) then begin MessageDlg('Le spectre de data n''existe pas !', mtInformation,[mbOk], 0);exit end;
   Qmin:=QzminDPbox.value;Qmax:=QzmaxDPbox.value;Qstep:=QzstepDPbox.value;
   sizeX:=round((Qmax-Qmin)/Qstep)+1;sizeY:=deuxd.spect[ind].Y;
   indQ:=deuxd.addspectre(dataQBox.text,sizeX,sizeY,1);
   for j:=0 to sizeY-1 do
   begin
     theta:=deuxd.spect[ind].data[0,j,0].Y;
     unD.add(deuxd.spect[ind].CoupeHSpectre2D('CH',theta));indCH:=unD.indexof('CH');
     for i:=0 to sizeX-1 do
     begin
        { dtermination de l'intensit pour une longueur d'onde donne             }
        Q:=Qmin+i*Qstep;
        lambda:=4*pi/Q*sin(theta*pi/180);
        deuxd.spect[indQ].data[i,j,0].X:=Q;
        deuxd.spect[indQ].data[i,j,0].Y:=theta;
        deuxd.spect[indQ].data[i,j,0].Z:=und.spect[indCH].interpolate(lambda);;
     end;
   end;
end;

procedure TTiltofForm.MapQbuttonClick(Sender: TObject);
begin MapQ end;

procedure TTiltofForm.AllButtonClick(Sender: TObject);
begin
    MapLambda;
    NormLambda;
    CalcTi;
    MapQ;
end;

{ trac de la trajectoire de rfrence sur la figure }
procedure TTiltofForm.PlotTrajButtonClick(Sender: TObject);
var indA,indR,indAi,indRi,ind,indT:integer;
    i,j:integer;
    sizeX,sizeY,sizeXA,sizeXR:integer;
    MA,MA0aller,MA0retour,t,pix0:double;
begin
   { inversion des trajectoires Aller et Retour                                 }
   { pour pouvoir directement obtenir le temps  partir de MA                   }
   indA:=und.indexof(TrajAllerBox.text);indR:=und.indexof(TrajRetourBox.text);
   if (indA=-1) or (indR=-1) then begin MessageDlg('Le spectre de data n''existe pas !', mtInformation,[mbOk], 0);exit end;
   sizeXA:=und.spect[indA].X;sizeXR:=und.spect[indR].X;
   indAi:=und.addspectre(TrajAllerBox.text+'I',sizeXA,1,1);
   indRi:=und.addspectre(TrajRetourBox.text+'I',sizeXR,1,1);
   for i:=0 to sizeXA-1 do
   begin
      und.spect[indAi].data[i,0,0].X:=und.spect[indA].data[i,0,0].Z;
      und.spect[indAi].data[i,0,0].Z:=und.spect[indA].data[i,0,0].X;
   end;
   for i:=0 to sizeXR-1 do
   begin
      und.spect[indRi].data[i,0,0].X:=und.spect[indR].data[i,0,0].Z;
      und.spect[indRi].data[i,0,0].Z:=und.spect[indR].data[i,0,0].X;
   end;

   { reconstruction proprement dite                                             }
   ind:=deuxd.indexof(RawDataBox.text);
   sizeX:=deuxd.spect[ind].X;sizeY:=deuxd.spect[ind].Y;
   indT:=deuxd.addspectre('Trajectoire',sizeX,sizeY,1); { le spectre gradu en lambda en abscisse }
   { on recopie le spectre de dpart dans le spectre "trajectoire }
   for i:=0 to sizeX-1 do for j:=0 to sizeY-1 do deuxd.spect[indT].data[i,j,0].Z:=deuxd.spect[ind].data[i,j,0].Z;

   { on balaie les diffrentes lignes du spectre brut }
   for j:=0 to sizeY-1 do
   begin
     { dtermination de la position MA  laquelle correspond la ligne j }
     { les j croissants correspondent  des MA decroissants ; j diminue quand theta augmente }
     MA:=(PixCalBox.value-j)*PixelSizeMABox.value+MaCalBox.value;
     { trajet "INCREASING" }
     { ... }
     { trajet "DECREASING" } { pour le moment les data dispo sont essentiellement "Decraesing" }
     { dcalage temporelle }
     t:=und.spect[indRi].interpolate(MA)*1000; { le facteur 1000 vient du fait qu'on calibre la trajectoire en ms et on veut t en s }
     { premier pixel correspondant au dbut du TOF }
     pix0:=channel0RBox.value+t/channelWidthBox.value;
     if (round(pix0)>=0) and (round(pix0)<sizeX) then deuxd.spect[indT].data[round(pix0),j,0].Z:=+1e8;

   end;
end;

{ traitement divers sur la trajectoire mesure }
procedure TTiltofForm.ProcessTrajectoryButtonClick(Sender: TObject);
var i,j,ind,indA,indR,X0,Xsize,jAmax,jRmax:integer;
    t,t0,MA,MA0:double;
    Np:integer;
    montant:boolean;
begin
   ind:=und.indexof(TrajectoryBox.text);X0:=und.spect[ind].X;
   if (ind=-1) then begin MessageDlg('Le spectre de data n''existe pas !', mtInformation,[mbOk], 0);exit end;
   { creation de la trajectoire traite ; function inverse T vs MA }
   indA:=und.addSpectre('TrajI',500,1,1);indR:=und.addSpectre('TrajD',500,1,1);
   { purge des abscisses des spectres (gradues par dfaut de 1 en 1 }
   for i:=0 to 499 do begin und.spect[indA].data[i,0,0].x:=0;und.spect[indR].data[i,0,0].x:=0; end;
   { calcul d'une trajectoire moyenne } { on parcourt la trajectoire mesure    }
   { la trajectoire d'entre doit etre constiue d'un nombre fini de priodes   }
   { la premire mriode doit etre "montante"                                   }
   t0:=und.spect[ind].data[0,0,0].X;MA0:=und.spect[ind].data[0,0,0].Z;
   montant:=true;j:=0;Np:=1;
   jAmax:=+999;JRmax:=+999;
   i:=0;
   for i:=0 to X0-1 do
   begin
      t:=und.spect[ind].data[i,0,0].X;
      MA:=und.spect[ind].data[i,0,0].Z;
      if (MA>MA0) and (montant=false)
      then begin montant:=true;
                 if j<jRmax then jRmax:=j;j:=0;
                 t0:=t; { on est  un Tstep prs } { = gain marginal (surtout au niveau du changement de direction) }
                 inc(Np) { on entame une nouvelle priode } end;
      if (MA<MA0) and (montant=true)
      then begin montant:=false;
                 if j<jAmax then jAmax:=j;j:=0;
                 t0:=t end;
      t:=t-t0;
      if montant
      then begin
           und.spect[indA].data[j,0,0].x:=und.spect[indA].data[j,0,0].x+t;
           und.spect[indA].data[j,0,0].z:=und.spect[indA].data[j,0,0].z+MA;
           inc(j)
           end
      else begin
           und.spect[indR].data[j,0,0].x:=und.spect[indR].data[j,0,0].x+t;
           und.spect[indR].data[j,0,0].z:=und.spect[indR].data[j,0,0].z+MA;
           inc(j)
           end;
      MA0:=MA;
   end;
   { redimensionnement des tableaux }
   setlength(und.spect[indA].data,jAMax,1,1);und.spect[indA].X:=jAmax;
   setlength(und.spect[indR].data,jRMax,1,1);und.spect[indR].X:=jRmax;
   { moyennage }
   for i:=0 to jAmax-1 do
   begin
      und.spect[indA].data[i,0,0].x:=und.spect[indA].data[i,0,0].x/Np;
      und.spect[indA].data[i,0,0].z:=und.spect[indA].data[i,0,0].z/Np;
   end;
   for i:=0 to jRmax-1 do
   begin
      und.spect[indR].data[i,0,0].x:=und.spect[indR].data[i,0,0].x/Np;
      und.spect[indR].data[i,0,0].z:=und.spect[indR].data[i,0,0].z/Np;
   end;



end;

end.

